<?php

namespace TB\BenzerKonular\Entity;

use XF\Mvc\Entity\Structure;

class Thread extends XFCP_Thread
{
    public function getBenzerKonuImg()
    {
       $message = $this->FirstPost->message;        
       $url = null;

  if (stripos($message, '[/img]') !== false){
    
    preg_match('/\[(img|IMG)\]\s*(https?:\/\/([^*\r]+|[a-z0-9\/\\\._\- !]+))\[\/(img|IMG)\]/Ui',$message,$matches);
  
           if(!$matches)
        {
            return false;
        }

        $url = $matches[2];

        $linkInfo = \XF::app()->stringFormatter()->getLinkClassTarget($url);
        
        if ($linkInfo['local'])
        {
            return $url;
        }
        
        if(\XF::app()->options()->imageLinkProxy['images'])
        {
            $proxyUrl = \XF::app()->stringFormatter()->getProxiedUrlIfActive('image', $url);
            return $proxyUrl;
        }

    } else if (stripos($message, '[/attach]') !== false){
	preg_match('/\[(attach.*|ATTACH)\](.+?)\[\/(attach|ATTACH)\]/Ui',$message,$matches);
    
        if(!$matches)
        {
            return false;
        }

		$url = \XF::app()->options()->boardUrl.'/attachments/'.$matches[2].'/';

        $linkInfo = \XF::app()->stringFormatter()->getLinkClassTarget($url);
        
        if ($linkInfo['local'])
        {
            return $url;
        }
        
        if(\XF::app()->options()->imageLinkProxy['images'])
        {
            $proxyUrl = \XF::app()->stringFormatter()->getProxiedUrlIfActive('image', $url);
            return $proxyUrl;
        }

    } else if (stripos($message, '[/tbr]') !== false){
	preg_match('/\[(tbr|TBR)\]\s*(https?:\/\/([^*\r]+|[a-z0-9\/\\\._\- !]+))\[\/(tbr|TBR)\]/Ui',$message,$matches);
    
        if(!$matches)
        {
            return false;
        }

        $url = $matches[2];

        $linkInfo = \XF::app()->stringFormatter()->getLinkClassTarget($url);
        
        if ($linkInfo['local'])
        {
            return $url;
        }
        
        if(\XF::app()->options()->imageLinkProxy['images'])
        {
            $proxyUrl = \XF::app()->stringFormatter()->getProxiedUrlIfActive('image', $url);
            return $proxyUrl;
        }

    } elseif (stripos($message, '[/tbr2]') !== false){
    preg_match('/\[(tbr2=(https?:\/\/([^*\r]+|[a-z0-9\/\\\._\- !]+))|TBR2)\]\s*(([^*\r]+|[a-z0-9\/\\\._\- !]+))\[\/(tbr2|TBR2)\]/Ui',$message,$matches);
        if(!$matches)
        {
            return false;
        }

        $url = $matches[2];

        $linkInfo = \XF::app()->stringFormatter()->getLinkClassTarget($url);
        
        if ($linkInfo['local'])
        {
            return $url;
        }
        
        if(\XF::app()->options()->imageLinkProxy['images'])
        {
            $proxyUrl = \XF::app()->stringFormatter()->getProxiedUrlIfActive('image', $url);
            return $proxyUrl;
        }


  } elseif (stripos($message, '[/krsag]') !== false){
    preg_match('/\[(krsag=(https?:\/\/([^*\r]+|[a-z0-9\/\\\._\- !]+))|KRSAG)\]\s*(([^*\r]+|[a-z0-9\/\\\._\- !]+))\[\/(krsag|KRSAG)\]/Ui',$message,$matches);
        if(!$matches)
        {
            return false;
        }

        $url = $matches[2];

        $linkInfo = \XF::app()->stringFormatter()->getLinkClassTarget($url);
        
        if ($linkInfo['local'])
        {
            return $url;
        }
        
        if(\XF::app()->options()->imageLinkProxy['images'])
        {
            $proxyUrl = \XF::app()->stringFormatter()->getProxiedUrlIfActive('image', $url);
            return $proxyUrl;
        }

    } elseif (stripos($message, '[/krsol]') !== false){
    preg_match('/\[(krsol=(https?:\/\/([^*\r]+|[a-z0-9\/\\\._\- !]+))|KRSOL)\]\s*(([^*\r]+|[a-z0-9\/\\\._\- !]+))\[\/(krsol|KRSOL)\]/Ui',$message,$matches);
        if(!$matches)
        {
            return false;
        }

        $url = $matches[2];

        $linkInfo = \XF::app()->stringFormatter()->getLinkClassTarget($url);
        
        if ($linkInfo['local'])
        {
            return $url;
        }
        
        if(\XF::app()->options()->imageLinkProxy['images'])
        {
            $proxyUrl = \XF::app()->stringFormatter()->getProxiedUrlIfActive('image', $url);
            return $proxyUrl;
        }


} elseif (stripos($message, '[/media]') !== false){
    if(preg_match('/\[(media=youtube|MEDIA)\](.+?)\[\/(media|MEDIA)\]/Ui',$message,$matches)) {
        if(!$matches)
        {
            return false;
        }

        $url = 'https://i4.ytimg.com/vi/'.$matches[2].'/0.jpg';

        $linkInfo = \XF::app()->stringFormatter()->getLinkClassTarget($url);
        
        if ($linkInfo['local'])
        {
            return $url;
        }
        
        if(\XF::app()->options()->imageLinkProxy['images'])
        {
            $proxyUrl = \XF::app()->stringFormatter()->getProxiedUrlIfActive('image', $url);
            return $proxyUrl;
        }

		} else {
		   //fb bas
		 preg_match('/\[(media=facebook|MEDIA)\](.+?)\[\/(media|MEDIA)\]/Ui',$message,$matches);
        if(!$matches)
        {
            return false;
        }

        $url = 'https://graph.facebook.com/'.$matches[2].'/picture';

        $linkInfo = \XF::app()->stringFormatter()->getLinkClassTarget($url);
        
        if ($linkInfo['local'])
        {
            return $url;
        }
        
        if(\XF::app()->options()->imageLinkProxy['images'])
        {
            $proxyUrl = \XF::app()->stringFormatter()->getProxiedUrlIfActive('image', $url);
            return $proxyUrl;
        }

		//fb son
	  } //if media
 }

        return $url;
    }

    public static function getStructure(Structure $structure)
    {
        $structure = parent::getStructure($structure);
        $structure->getters['benzer_konu_img'] = true;

        return $structure;
    }
}